codeforces 709 D Recover the String (构造)

D. Recover the String
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

For each string s consisting of characters '0' and '1' one can define four integers a00a01a10 and a11, where axy is the number ofsubsequences of length 2 of the string s equal to the sequence {x, y}.

In these problem you are given four integers a00a01a10a11 and have to find any non-empty string s that matches them, or determine that there is no such string. One can prove that if at least one answer exists, there exists an answer of length no more than 1 000 000.

Input

The only line of the input contains four non-negative integers a00a01a10 and a11. Each of them doesn't exceed 109.

Output

If there exists a non-empty string that matches four integers from the input, print it in the only line of the output. Otherwise, print "Impossible". The length of your answer must not exceed 1 000 000.

Examples
input
1 2 3 4
output
Impossible
input
1 2 2 1
output
0110

题意:

一个字符串只能有0和1,现在告诉你字符串里00,01,10,11(可以不是连续)的个数,问你能不能找到这样一个字符串,可以的话输出。

思路:

首先我们可以从00和11的对数找到0和1的个数,这里要小心如果是0的话可以是0个或1个。然后对于1个字符串,0要么在1前面要么在1后面,所以01和10的个数加起来应该是cnt0*cnt1,好现在开始构造,假如我们第一个输出0,那么这个问题就变成了cnt0-1个9,cnt1个1,cnt01-cnt1个01,cnt10个10能否构成一个串,不行的话就输出1,所以我们只要循环判断就行了。

代码:

#include <bits/stdc++.h>

using namespace std;

int _00,_01,_10,_11;
vector<int>po0,po1;

void get(int v, vector<int>&p){
	if(v == 0) p.push_back(0);
	for(int i = 1; i < 1e5; ++i)
		if((i-1)*i/2 == v){
			p.push_back(i);
			break;
		}
}

inline bool check(int cnt0, int a01, int a10, int cnt1){
	if(cnt0<0 ||cnt1<0||a01<0||a10<0) return false;
	return cnt0*cnt1 == a01 + a10;
}

int main(){
	bool ok = false;
	int n0 = -1,n1 = -1;
	cin>>_00>>_01>>_10>>_11;
	get(_00,po0);get(_11,po1);
	for(auto i:po0) 
		for(auto j:po1) 
			if(check(i,_01,_10,j)){
				ok = true; n0 = i; n1 = j; break;
			}
	if(!ok ) return puts("Impossible"),0;
	while(n0>0||n1>0){
		if(check(n0-1,_01-n1,_10,n1)){
			putchar('0');
			n0--;
			_01-=n1;
		}else{
			putchar('1');
			n1--;
			_10-=n0;
		}
	}
	puts("");
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值